# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

# Declaring specific app values (TO CHANGE)
bin_name_x86 = 'vcredist_x86.exe'
bin_name_x64 = 'vcredist_x64.exe'
silent_args = '/Q'
uninstall_key_x86 = '{61087a79-ac85-455c-934d-1fa22cc64f36}'
uninstall_key_x64 = '{ef6b00ec-13e1-4c25-9064-b2f383cb8412}'
url_dl_x86 = 'https://download.microsoft.com/download/0/5/6/056dcda9-d667-4e27-8001-8a0c6971d6b1/vcredist_x86.exe'
url_dl_x64 = 'https://download.microsoft.com/download/0/5/6/056dcda9-d667-4e27-8001-8a0c6971d6b1/vcredist_x64.exe'
short_soft_name = 'Microsoft Visual C++ 2013 Redistributable'


def install():
    print('installing %s' % control.asrequirement())

    # Specific app values
    package_version = control.version.split('-',1)[0]

    # Uninstalling older versions
    check_installed = installed_softwares(short_soft_name)
    #print(check_installed)
    for uninstall in check_installed:
        if uninstall['version'] < package_version:
            print('Removing %s' % uninstall['name'])
            cmd = uninstall_cmd(uninstall['key'])
            run(cmd)

    # Getting the used storage on programfiles before installation (place it on the top)
    get_disk_free_space_before = get_disk_free_space(programfiles)

    # Installing the package
    install_exe_if_needed(bin_name_x86
        ,silentflags=silent_args
        ,key=uninstall_key_x86
        ,min_version=package_version)

    if iswin64():
        install_exe_if_needed(bin_name_x64
            ,silentflags=silent_args
            ,key=uninstall_key_x64
            ,min_version=package_version)

    # Return used storage of the program. (place it on the bottom)
    get_disk_free_space_after = get_disk_free_space(programfiles)
    free_space_after_diff = get_disk_free_space_before - get_disk_free_space_after
    print("Storage used: " + str(free_space_after_diff))


def update_package():
    print('Update/Download package content from upstream binary sources')

    # Getting proxy informations from WAPT settings
    proxy = {}
    if isfile(makepath(application_data(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}

    # Downloading binaries
    if not isfile(bin_name_x86):
        print('Downloading ' + bin_name_x86)
        wget(url_dl_x86,bin_name_x86,proxies=proxy)

    if not isfile(bin_name_x64):
        print('Downloading ' + bin_name_x64)
        wget(url_dl_x64,bin_name_x64,proxies=proxy)
    #get version from file
    version = '.'.join(get_file_properties(bin_name_x86)['ProductVersion'].split('.')[:3])
    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    control.version = '%s-%s' % (Version(version), control.version.split('-', 1)[-1])
    #control.set_software_version(Version(version))
    control.save_control_to_wapt()